#ifndef OVERLOAD_H
#define OVERLOAD_H

#include <string>

// Define some overloaded functions

int overloadedFunc(int a) {
   return a; 
}

int overloadedFunc(const std::string& b) {
    return strlen(b.c_str());
}


// Define a namespace for wrapper class

namespace wrapperNS {

// Define a class that calls overloadedFunc

    class wrapper {
    public:

        template<class T>
        int callOverloaded(const T& ref) {
           return ::overloadedFunc(ref);
        }

    };

} // wrapperNS

#endif // OVERLOAD_H